define("format_flexsections/local/content",["exports","core_courseformat/local/content","core_courseformat/courseeditor","format_flexsections/local/content/section","core_courseformat/local/content/section/cmitem","format_flexsections/local/courseeditor/mutations","format_flexsections/local/content/actions","format_flexsections/local/courseeditor/exporter"],(function(_exports,_content,_courseeditor,_section,_cmitem,_mutations,_actions,_exporter){function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}
/**
   * Course format component
   *
   * @module     format_flexsections/local/content
   * @copyright  2022 Marina Glancy
   * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
   */Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.default=void 0,_content=_interopRequireDefault(_content),_section=_interopRequireDefault(_section),_cmitem=_interopRequireDefault(_cmitem),_mutations=_interopRequireDefault(_mutations),_actions=_interopRequireDefault(_actions),_exporter=_interopRequireDefault(_exporter);class FlexsectionComponent extends _content.default{static init(target,selectors,sectionReturn){var _courseEditor$mutatio,_courseEditor$mutatio2;const courseEditor=(0,_courseeditor.getCurrentCourseEditor)();courseEditor.getExporter=()=>new _exporter.default(courseEditor);let legacyActivityAction=null!==(_courseEditor$mutatio=courseEditor.mutations.legacyActivityAction)&&void 0!==_courseEditor$mutatio?_courseEditor$mutatio:null,legacySectionAction=null!==(_courseEditor$mutatio2=courseEditor.mutations.legacySectionAction)&&void 0!==_courseEditor$mutatio2?_courseEditor$mutatio2:null;return courseEditor.setMutations(new _mutations.default),courseEditor.addMutations({...legacyActivityAction?{legacyActivityAction:legacyActivityAction}:{},...legacySectionAction?{legacySectionAction:legacySectionAction}:{}}),new FlexsectionComponent({element:document.getElementById(target),reactive:courseEditor,selectors:selectors,sectionReturn:sectionReturn})}create(descriptor){super.create(descriptor),this.name="course_format_flexsections",this.selectors.COURSE_SUBSECTIONLIST="[data-for='course_subsectionlist']"}stateReady(state){super.stateReady(state),this.reactive.supportComponents&&this.reactive.isEditing&&new _actions.default(this),state.course.accordion&&(this._ensureOnlyOneSectionIsExpanded(state),window.addEventListener("hashchange",this._hashHandler.bind(this)))}_ensureOnlyOneSectionIsExpanded(state){const isExpanded=sectionInfo=>!sectionInfo.showaslink&&!sectionInfo.contentcollapsed,hasExpandedChildren=sectionInfo=>{var _sectionInfo$children;return(null!==(_sectionInfo$children=sectionInfo.children)&&void 0!==_sectionInfo$children?_sectionInfo$children:[]).some((s=>isExpanded(s)))};let firstExpandedSection=null;for(let sectionInfo of this._getSectionsWithCollapse(state))firstExpandedSection||!isExpanded(sectionInfo)||hasExpandedChildren(sectionInfo)||(firstExpandedSection=sectionInfo);if(firstExpandedSection){const sectionitem=this.getElement(this.selectors.SECTION,firstExpandedSection.id);this._collapseAllSectionsExceptFor(sectionitem,!1)}}getWatchers(){let res=super.getWatchers();return res.push({watch:"course.hierarchy:updated",handler:this._refreshCourseHierarchy}),res.push({watch:"section.showaslink:updated",handler:this._reloadSection}),res}_refreshCourseHierarchy(_ref){var _element$hierarchy;let{element:element}=_ref;const hierarchy=null!==(_element$hierarchy=element.hierarchy)&&void 0!==_element$hierarchy?_element$hierarchy:[],createSection=this._createSectionItem.bind(this);for(let i=0;i<hierarchy.length;i++){const sectionlist=hierarchy[i].children,listparent=this.getElement(this.selectors.COURSE_SUBSECTIONLIST+"[data-parent='".concat(hierarchy[i].id,"']"));listparent&&this._fixOrder(listparent,sectionlist,this.selectors.SECTION,this.dettachedSections,createSection)}}_indexContents(){this._scanIndex(this.selectors.SECTION,this.sections,(item=>new _section.default(item))),this._scanIndex(this.selectors.CM,this.cms,(item=>new _cmitem.default(item)))}_sectionTogglers(event){const sectionlink=event.target.closest(this.selectors.TOGGLER),closestCollapse=event.target.closest(this.selectors.COLLAPSE),isChevron=null==closestCollapse?void 0:closestCollapse.closest(this.selectors.SECTION_ITEM);if(sectionlink||isChevron){var _toggler$classList$co;const section=event.target.closest(this.selectors.SECTION),toggler=section.querySelector(this.selectors.COLLAPSE),isCollapsed=null!==(_toggler$classList$co=null==toggler?void 0:toggler.classList.contains(this.classes.COLLAPSED))&&void 0!==_toggler$classList$co&&_toggler$classList$co;if(isChevron||isCollapsed){const sectionId=parseInt(section.getAttribute("data-id"));this.reactive.dispatch("sectionContentCollapsed",[sectionId],!isCollapsed)}isCollapsed&&this.reactive.stateManager.state.course.accordion&&this._collapseAllSectionsExceptFor(section)}}_collapseAllSectionsExceptFor(section){let scrollToSection=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];const sectionNumber=parseInt(section.getAttribute("data-sectionid")),leaveOpen=[...this._findAllParents(sectionNumber),sectionNumber];sectionNumber>0&&leaveOpen.includes(0)&&leaveOpen.splice(leaveOpen.indexOf(0),1);const sectionIds=this._getSectionsWithCollapse(this.reactive.stateManager.state).filter((s=>!leaveOpen.includes(parseInt(s.section)))).map((s=>s.id));if(this.reactive.dispatch("sectionContentCollapsed",sectionIds,!0),scrollToSection){const toggler=section.querySelector(this.selectors.COLLAPSE);setTimeout((()=>{toggler.scrollIntoView({behavior:"smooth",block:"nearest"})}),500)}}_refreshAllSectionsToggler(state){const target=this.getElement(this.selectors.TOGGLEALL);if(!target)return;let allcollapsed=!0;const mainSection=this._mainSection(),sections=this._getSectionsWithCollapse(state);for(let i in sections)parseInt(sections[i].parent)===mainSection&&(allcollapsed=allcollapsed&&sections[i].contentcollapsed);allcollapsed?(target.classList.add(this.classes.COLLAPSED),target.setAttribute("aria-expanded",!1)):(target.classList.remove(this.classes.COLLAPSED),target.setAttribute("aria-expanded",!0))}_allSectionToggler(event){event.preventDefault();const isAllCollapsed=event.target.closest(this.selectors.TOGGLEALL).classList.contains(this.classes.COLLAPSED),sections=this._getSectionsWithCollapse();let ids=[];for(let i in sections)ids.push(sections[i].id);this.reactive.dispatch("sectionContentCollapsed",ids,!isAllCollapsed)}_mainSection(){return parseInt(this.element.getAttribute("data-flexsections-mainsection"))}_getSectionsWithCollapse(state){void 0===state&&(state=this.reactive.stateManager.state);const mainSection=this._mainSection();let parents={};parents["".concat(mainSection)]="".concat(mainSection);let displayedSections=[];return state.section.forEach((section=>{var _this$getElement;const sectionNumber=parseInt(section.number);(null===(_this$getElement=this.getElement(this.selectors.SECTION,section.id))||void 0===_this$getElement?void 0:_this$getElement.querySelector(this.selectors.COLLAPSE))&&"".concat(section.parent)in parents&&!section.showaslink&&(parents["".concat(sectionNumber)]="".concat(sectionNumber),displayedSections.push(section))})),displayedSections}_findAllParents(thisSectionNumber){if(thisSectionNumber===this._mainSection())return[];let section=this.reactive.stateManager.state.section.find((section=>parseInt(section.number)===thisSectionNumber));if(section&&void 0!==section.parent){const parent=parseInt(section.parent);return[...this._findAllParents(parent),parent]}return[]}_hashHandler(){var _window$location$hash;if((null!==(_window$location$hash=window.location.hash)&&void 0!==_window$location$hash?_window$location$hash:"").length<=1)return;const target=document.querySelector("".concat(window.location.hash).concat(this.selectors.SECTION));if(!target)return;if(target.querySelector(this.selectors.COLLAPSE)){const sectionNumber=parseInt(target.getAttribute("data-sectionid")),toExpand=[...this._findAllParents(sectionNumber),sectionNumber].filter((s=>s>0)),sectionIds=this._getSectionsWithCollapse(this.reactive.stateManager.state).filter((s=>toExpand.includes(parseInt(s.section)))).map((s=>s.id));this.reactive.dispatch("sectionContentCollapsed",sectionIds,!1),this._collapseAllSectionsExceptFor(target)}}}return _exports.default=FlexsectionComponent,_exports.default}));

//# sourceMappingURL=content.min.js.map